pkg_delete(1)

NAME
pkg_delete - a utility for deleting previously installed software package distributions

SYNOPSIS
[-vDdnFfOrR] [-p prefix] pkg-name ...

DESCRIPTION
The pkg_delete command is used to delete packages that have been previously installed with the pkg_add(1) command.

WARNING
Since the pkg_delete command may execute scripts or programs provided by a package file, your system may be susceptible to ``trojan horses'' or other subtle attacks from miscreants who create dangerous package files.

You are advised to verify the competence and identity of those who provide installable package files. For extra protection, examine all the package control files in the package record directory ( /var/db/pkg/<pkg-name>/ ). Pay particular attention to any +INSTALL, +DEINSTALL, +REQUIRE or +MTREE_DIRS files, and inspect the +CONTENTS file for @cwd, @mode (check for setuid), @dirrm, @exec, and @unexec directives, and/or use the pkg_info(1) command to examine the installed package control files.

OPTIONS
The following command line options are supported:

pkg-name ...
    The named packages are deinstalled, wildcards can be used, see pkg_info(1). If no version is given, the one currently installed will be removed. If the -F flag is given, one or more (absolute) filenames may be specified and the Package Database will be consulted for the package to which the given file belongs. These packages are then deinstalled.

-v  Turn on verbose output.

-D  If a deinstallation script exists for a given package, do not execute it.

-n  Don't actually deinstall a package, just report the steps that would be taken if it were.

-O  Only delete the package's entries from the package database, do not touch the package or it's files itself.

-p prefix
    Set prefix as the directory in which to delete files from any installed packages which do not explicitly set theirs. For most packages, the prefix will be set automatically to the installed location by pkg_add(1).

-r  Pkg_delete first builds a list of all packages that require (directly and indirectly) the one being deleted. It then deletes these packages using pkg_delete with the given options before deleting the user specified package.

-R  Like the -r option, this does a recursive delete. The -R option deletes the given package and any packages required by it, unless some other package still needs them. This can be used to delete a package and all the packages it needs.

-d  Remove empty directories created by file cleanup. By default, only files/directories explicitly listed in a package's contents (either as normal files/directories or with the @dirrm directive) will be removed at deinstallation time. This option tells pkg_delete to also remove any directories that were emptied as a result of removing the package.

-F  Any pkg-name given will be interpreted as pathname which is subsequently transformed in a (real) package name via the Package Database. That way, packges can be deleted by giving a filename instead of the package-name.

-f  Force removal of the package, even if a dependency is recorded or the deinstall or require script fails.

TECHNICAL DETAILS
pkg_delete does pretty much what it says. It examines installed package records in /var/db/pkg/<pkg-name>, deletes the package contents, and finally removes the package records.

If a package is required by other installed packages, pkg_delete will list those dependent packages and refuse to delete the package (unless the -f option is given).

If a filename is given instead of a package name, the package of which the given file belongs to can be deleted if the -F Flag is given. The filename needs to be absolute, see the output produced by the pkg_info -aF command.

If the package contains a require file (see pkg_create(1) ), then this is executed first as
require <pkg-name> DEINSTALL

(where pkg-name is the name of the package in question and DEINSTALL is a keyword denoting that this is a deinstallation) to see whether or not deinstallation should continue. A non-zero exit status means no, unless the -f option is specified.

If a deinstall script exists for the package, it is executed before and after any files are removed. It is this script's responsibility to clean up any additional messy details around the package's installation, since all pkg_delete knows how to do is delete the files created in the original distribution. The deinstall script is called as:
deinstall <pkg-name> DEINSTALL

before deleting all files and as:
deinstall <pkg-name> POST-DEINSTALL

after deleting them. Passing the keywords DEINSTALL and POST-DEINSTALL lets you potentially write only one program/script that handles all aspects of installation and deletion.

All scripts are called with the environment variable PKG_PREFIX set to the installation prefix (see the -p option above). This allows a package author to write a script that reliably performs some action on the directory where the package is installed, even if the user might have changed it by specifying the -p option when running pkg_delete or pkg_add.

SEE ALSO
pkg_add(1), pkg_admin(1), pkg_create(1), pkg_info(1), mktemp(3), mtree(8).

AUTHORS
Jordan Hubbard
    most of the work
John Kohl
    refined it for NetBSD
Hubert Feyrer
    NetBSD wildcard dependency processing, pkgdb, recursive "down" delete, etc.